#line 32 "lexer.l"
#include "config.h"
#include "rsyslog.h"
#include "srUtils.h"



#line 9 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 105
#define YY_END_OF_BUFFER 106
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[531] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  106,  104,  103,  103,  104,  104,
      104,   45,   76,  104,  104,  104,  104,   81,  104,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   46,   47,   75,  103,   76,  104,  104,  104,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   96,   95,   95,   96,   96,   82,
       84,   96,   87,   83,   85,   86,   93,   93,   93,   59,
       59,   58,   57,   56,   43,   42,   42,   43,   41,   39,
       39,   41,   41,   41,   13,   15,   41,   19,   20,   11,

       14,   10,   16,   12,   35,   35,    5,   26,    9,   27,
       40,   40,   40,   40,   40,   40,   40,   40,   40,   17,
       18,    0,    0,  102,    0,    0,   80,   80,   80,   78,
       89,   81,    0,   81,   81,   81,   81,   81,   81,    1,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,    0,    0,    0,    0,    0,    0,    0,
        0,   80,    0,    0,    0,   81,   81,   81,   81,   81,
       81,   81,   81,   81,    1,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,    0,   88,
        0,    0,   94,   90,   83,   93,   93,   92,   60,   56,

       44,   24,    0,   38,    0,    0,   36,    0,   37,    0,
       91,   33,    0,   35,   22,   25,   21,   23,   40,   40,
       40,    4,   29,   40,    6,   40,   40,    0,   98,    0,
       97,    0,    0,  100,    0,   80,   80,   77,   77,   78,
       79,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   51,   81,   81,   81,
       81,   74,    0,  101,   80,    0,    0,   74,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   51,   81,   81,   81,   81,    0,    0,
        0,   36,    0,    0,   34,    7,   40,    8,   40,   40,

        0,   99,   80,   77,   77,   79,   81,   50,   81,   81,
       49,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   48,   81,   81,   81,    0,    0,    0,   81,
       50,   81,   81,   49,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   48,   81,   81,   81,    0,
        0,    0,    0,    0,   40,   40,    3,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   52,
       81,   81,   81,   53,    0,    0,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   52,   81,   81,
       81,   53,    0,   40,   40,   81,   81,   81,   81,   81,

        0,   69,   81,   81,   81,   81,   81,   81,   81,   81,
       81,    0,    0,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   40,   40,    0,   72,
       81,   81,    2,    0,   64,   81,   81,    0,   70,    0,
       63,   81,   81,   81,   81,   81,    0,   73,    0,   81,
       81,    2,   81,   81,   81,   81,   81,   40,   40,   81,
       54,   81,   81,   81,   81,    0,   66,   81,   81,   73,
       81,   54,   81,   81,   81,   81,   28,   40,    0,   68,
       81,   81,   81,    0,   67,    0,   65,    0,   62,   81,
       40,   40,   81,   81,   81,   81,   30,   31,   81,    0,

       61,   81,   81,   40,   81,   81,   81,   32,    0,   71,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   55,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
       46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
       56,   57,   58,   59,   60,    1,   61,   62,   63,   64,

       65,   66,   67,   68,   69,   39,   70,   71,   72,   73,
       74,   75,   76,   77,   78,   79,   80,   51,   81,   82,
       83,   84,   85,   59,   86,   87,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[88] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,   13,   14,
       14,   15,   16,   17,    1,   18,    1,   19,   20,   21,
       22,   23,   23,   23,   21,   24,   24,   24,   24,   24,
       24,   24,   25,   24,   24,   24,   25,   24,   25,   24,
       26,   24,   27,   24,   24,   28,    6,   28,    1,   29,
       21,   22,   23,   23,   23,   21,   24,   24,   24,   24,
       24,   24,   25,   24,   24,   24,   25,   24,   25,   24,
       24,   27,   24,   24,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[606] =
    {   0,
        0,   87,  174,    0,  259,  260,  262,  265,  257,  262,
      284,    0,  371,    0, 1256, 3724, 3724, 3724,    0, 1234,
        0, 3724, 3724, 1210,  257,    0, 1206,    0,    0,  427,
      430,  421,  419,  423,  430,  423,  438,  439,  437,  436,
      441,  434, 3724, 3724,    0,  507,  460, 1204,  530,  506,
      546,  559,  606,  564,  521,  570,  599,  588,  603,  607,
      625,  627,  649,  652, 3724, 3724, 3724,  512, 1096, 3724,
     3724, 1079, 3724,    0, 3724, 3724, 1085, 1046, 1002,    0,
     3724, 3724, 3724,  499, 3724, 3724, 3724,    0, 3724, 3724,
     3724,  960,  527,  594, 3724, 3724,  472, 3724, 3724, 3724,

     3724, 3724, 3724,  933,  625,  571, 3724,  254,  915,  854,
      452,    0,  527,  566,  627,  630,  638,  640,  535, 3724,
     3724,  594,  874, 3724,  726,  812,    0,  818,  458,    0,
     3724,    0,  835,  642,  653,  774,  770,  776,  780,    0,
      781,  783,  790,  796,  784,  798,  786,  794,  787,  793,
      796,  797,  792,  869,  532,    0,  847,  825,    0,  858,
      847,  892,  822,  704,  906,  920,  867,  939,  951,  891,
      866,  865,  927,  938,  803,  939,  941,  953,  959,  947,
      985,  949,  954,  934,  961,  967,  994,  993,  601, 3724,
      468,  719, 3724, 3724,    0,  660,  650, 3724,    0,  869,

        0, 3724,  646, 3724, 1024,    0,    0,  645, 3724, 1027,
     3724,  677,    0, 1031, 3724, 3724, 3724, 3724,    0,  811,
      958,    0,    0,  958,    0,  851,  899, 1052, 3724,  645,
     3724, 1109, 1058, 1072,  636, 1079,  601,    0,    0,    0,
        0,  920, 1016, 1019, 1024, 1029, 1038, 1028, 1157, 1155,
     1149, 1152, 1156, 1157, 1036, 1169,    0, 1160, 1161, 1173,
     1174,    0, 1088, 3724, 1100,  920,  712, 1199, 1226, 1251,
     1174, 1192, 1217, 1229, 1233, 1214, 1235, 1239, 1246, 1252,
     1257, 1271, 1273, 1178, 1258, 1275, 1284, 1296, 1320,  910,
        0,    0, 1064,    0, 3724,    0, 1230,    0, 1254, 1272,

      582, 3724,  544,    0,    0,    0, 1277,    0, 1285, 1297,
        0, 1309, 1313, 1299, 1302,  448, 1312, 1320, 1309, 1323,
     1310, 1312,    0, 1321,  429, 1314, 1091, 1205, 1364, 1331,
     1324, 1330, 1335, 1340, 1357, 1366, 1350, 1353, 1359, 1343,
     1374, 1369, 1379, 1376, 1390, 1371, 1381, 1393, 1394, 1450,
     1191,    0, 1241,    0, 1393, 1383,    0, 1393, 1396, 1406,
     1409, 1410, 1472, 1408, 1412, 1425, 1416, 1423, 1422,    0,
     1426, 1448, 1436,    0,  977,  705, 1444, 1459, 1451, 1463,
     1441, 1499, 1473, 1464, 1472, 1484, 1480, 1445, 1497, 1506,
     1498, 1482, 1290, 1468, 1485, 1562, 1498, 1495, 1513, 1576,

     1580, 3724,  445, 1496, 1583, 1587, 1541, 1544, 1545, 1547,
     1554, 1101, 1502, 1598, 1562, 1557, 1572, 1613, 1570, 1617,
     1644, 1590, 1565, 1593, 1608, 1609, 1565,  781, 1663, 3724,
     1583, 1611,    0, 1687, 3724, 1602, 1621, 1690, 3724, 1693,
     3724, 1635, 1478, 1704, 1639, 1644, 1606, 3724, 1653, 1662,
     1678, 1627, 1679, 1659, 1719, 1683, 1691, 1679, 1690, 1732,
        0, 1707, 1689, 1702, 1749, 1761, 3724, 1772, 1775, 1723,
     1779, 1714, 1729, 1790, 1793, 1804,  438, 1709, 1807, 3724,
     1741, 1752, 1758, 1810, 3724, 1821, 3724, 1824, 3724, 1777,
     1763, 1767, 1780, 1835, 1781, 1808,    0,  406, 1806, 1850,

     3724, 1789, 1803, 1803, 1853, 1820, 1825,    0, 1865, 3724,
     1827, 1835, 1825, 1846, 1839, 1842, 1834, 1845, 1846, 1850,
     1862, 1866, 1864, 1868, 1854, 1863,  260, 1891, 3724, 3724,
     1962, 1991, 2020, 2049, 2078, 2087, 2114, 2143, 2164, 2180,
     2206, 2226, 2246, 2273, 2296, 2316, 2345, 2374, 2392, 2421,
     2450, 2469, 2498, 2523, 2550, 2566, 2595, 2624, 2653, 2682,
     2703, 2719, 2745, 2765, 2782, 2803, 2826, 2853, 2879, 2902,
     2924, 2953, 2977, 3003, 3021, 3050, 3079, 3098, 3127, 3151,
     3159, 3182, 3211, 3235, 1921, 3249, 3278, 3307, 3336, 3365,
     3394, 3423, 3452, 3481, 3502, 3527, 3551, 3574, 3596, 3625,

     3641, 3651, 3661, 3671, 3694
    } ;

static yyconst flex_int16_t yy_def[606] =
    {   0,
      530,  530,  530,    3,  531,  531,  532,  532,  533,  533,
      530,   11,  530,   13,  530,  530,  530,  530,  534,  535,
      536,  530,  530,  530,  537,  537,  538,  539,  540,  539,
      539,  539,  539,  539,  539,  539,  539,  539,  539,  539,
      539,  539,  530,  530,  537,  541,  542,  543,  544,  545,
      546,  546,  546,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,  530,  530,  530,  547,  548,  530,
      530,  530,  530,  549,  530,  530,  550,  550,  530,  551,
      530,  530,  530,  530,  530,  530,  530,  552,  530,  530,
      530,  530,  553,  554,  530,  530,  555,  530,  530,  530,

      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      556,  556,  556,  556,  556,  556,  556,  556,  556,  530,
      530,  557,  558,  530,  530,  530,  537,  537,  559,  560,
      530,  561,  562,  561,  561,  561,  561,  561,  561,  561,
      561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
      561,  561,  561,  563,  564,  565,  566,  564,  567,  530,
      565,  568,  566,  566,  569,  570,  561,  571,  571,  169,
      169,  169,  169,  169,  169,  169,  169,  169,  169,  169,
      169,  169,  169,  169,  169,  169,  169,  169,  572,  530,
      573,  574,  530,  530,  575,  576,  576,  530,  577,  530,

      578,  530,  579,  530,  580,  581,  582,  583,  530,  584,
      530,  530,  585,  530,  530,  530,  530,  530,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  530,  530,  587,
      530,  530,  530,  530,  588,  589,  590,  591,  592,  593,
      594,  595,  595,  595,  595,  595,  595,  595,  595,  595,
      595,  595,  595,  595,  595,  595,  595,  595,  595,  595,
      595,  596,  530,  530,  589,  530,  597,  598,  599,  599,
      270,  270,  270,  270,  270,  270,  270,  270,  270,  270,
      270,  270,  270,  270,  270,  270,  270,  270,  600,  530,
      601,  582,  530,  602,  530,  586,  586,  586,  586,  586,

      588,  530,  590,  591,  592,  594,  595,  595,  595,  595,
      595,  595,  595,  595,  595,  595,  595,  595,  595,  595,
      595,  595,  595,  595,  595,  595,  597,  597,  597,  270,
      270,  270,  270,  270,  270,  270,  270,  270,  270,  270,
      270,  270,  270,  270,  270,  270,  270,  270,  270,  600,
      530,  603,  530,  604,  586,  586,  586,  595,  595,  595,
      595,  595,  595,  595,  595,  595,  595,  595,  595,  595,
      595,  595,  595,  595,  530,  530,  270,  270,  270,  270,
      270,  270,  270,  270,  270,  270,  270,  270,  270,  270,
      270,  270,  600,  586,  586,  595,  595,  595,  595,  595,

      530,  530,  595,  595,  595,  595,  595,  595,  595,  595,
      595,  530,  605,  270,  270,  270,  270,  270,  270,  270,
      270,  270,  270,  270,  270,  270,  586,  586,  530,  530,
      595,  595,  595,  530,  530,  595,  595,  530,  530,  530,
      530,  595,  595,  595,  595,  595,  605,  530,  605,  270,
      270,  270,  270,  270,  270,  270,  270,  586,  586,  595,
      595,  595,  595,  595,  595,  530,  530,  595,  595,  605,
      270,  270,  270,  270,  270,  270,  586,  586,  530,  530,
      595,  595,  595,  530,  530,  530,  530,  530,  530,  270,
      586,  586,  595,  595,  595,  270,  586,  586,  595,  530,

      530,  595,  270,  586,  595,  595,  270,  586,  530,  530,
      595,  270,  595,  270,  595,  270,  595,  270,  595,  270,
      595,  270,  595,  270,  595,  270,  595,  270,  530,    0,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,

      530,  530,  530,  530,  530
    } ;

static yyconst flex_int16_t yy_nxt[3812] =
    {   0,
       16,   17,   18,   17,   19,   16,   20,   21,   16,   22,
       16,   16,   16,   23,   24,   16,   25,   26,   27,   28,
       28,   28,   29,   16,   16,   16,   26,   26,   26,   30,
       28,   31,   28,   32,   33,   34,   28,   35,   28,   28,
       36,   37,   28,   28,   38,   28,   39,   40,   41,   42,
       28,   28,   28,   28,   28,   16,   16,   16,   26,   28,
       30,   28,   31,   28,   32,   33,   34,   28,   35,   28,
       36,   37,   28,   28,   38,   28,   39,   40,   41,   42,
       28,   28,   28,   28,   43,   44,   45,   16,   46,   18,
       46,   19,   16,   20,   21,   16,   22,   16,   16,   16,

       47,   48,   16,   49,   26,   27,   28,   28,   28,   50,
       16,   16,   16,   26,   26,   26,   51,   52,   53,   52,
       54,   55,   56,   52,   57,   52,   52,   58,   59,   52,
       52,   60,   52,   61,   62,   63,   64,   52,   52,   52,
       52,   52,   16,   16,   16,   26,   28,   51,   52,   53,
       52,   54,   55,   56,   52,   57,   52,   58,   59,   52,
       52,   60,   52,   61,   62,   63,   64,   52,   52,   52,
       52,   43,   44,   45,   65,   66,   67,   66,   65,   68,
       69,   65,   65,   65,   65,   65,   70,   65,   65,   71,
       65,   65,   72,   65,   65,   65,   65,   65,   65,   73,

       65,   65,   65,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   75,
       65,   76,   65,   65,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   65,   65,
       65,   78,   78,   81,   81,   81,   81,   81,   81,   83,
      128,  529,   79,   79,   83,  129,   84,   84,   84,  215,
      216,   84,   84,   84,   85,   86,   87,   86,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,

       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   88,   88,   88,   88,   88,   88,   88,
       88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
       88,   88,   88,   88,   88,   88,   88,   88,   88,   85,
       85,   85,   85,   85,   88,   88,   88,   88,   88,   88,
       88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
       88,   88,   88,   88,   88,   88,   88,   88,   85,   85,
       85,   89,   90,   91,   90,   92,   93,   89,   94,   95,
       96,   97,   98,   99,  100,  101,  102,  103,   89,  104,
      105,  106,  106,   89,  107,  108,  109,  110,   89,   89,

      111,  112,  113,  114,  112,  112,  112,  112,  115,  112,
      112,  112,  112,  116,  117,  112,  112,  112,  118,  119,
      112,  112,  112,  112,  112,  112,  120,   89,  121,   89,
       89,  111,  112,  113,  114,  112,  112,  112,  112,  115,
      112,  112,  112,  116,  117,  112,  112,  112,  118,  119,
      112,  112,  112,  112,  112,   89,   89,   89,  134,  135,
      239,  137,  138,  139,  140,  504,  142,  143,  145,  149,
      147,  127,  141,  136,  151,  159,  153,  159,  152,  160,
      160,  144,  209,  373,  150,  146,  148,  289,  289,  134,
      135,  137,  138,  139,  220,  140,  142,  491,  143,  145,

      149,  147,  141,  136,  436,  151,  153,  365,  154,  152,
      154,  144,  373,  163,  150,  146,  148,  190,  200,  200,
      200,  156,  164,  156,  220,  133,  133,  133,  210,  157,
      127,  127,  204,  127,  127,  127,  127,  127,  127,  127,
      127,  127,  127,  128,  127,  127,  302,  159,  129,  159,
      168,  160,  160,  127,  127,  127,  127,  127,  127,  158,
      132,  166,  132,  159,  173,  167,  167,  132,  191,  132,
      221,  227,  158,  132,  166,  132,  159,  169,  167,  167,
      132,  168,  132,  205,  302,  127,  127,  127,  127,  127,
      214,  214,  214,  168,  173,  228,  229,  228,  206,  168,

      221,  206,  227,  302,  172,  132,  190,  168,  169,  222,
      174,  206,  206,  168,  127,  127,  127,  168,  132,  158,
      132,  166,  132,  159,  168,  167,  167,  132,  168,  132,
      168,  177,  178,  175,  172,  170,  180,  168,  302,  222,
      174,  176,  168,  168,  212,  212,  179,  231,  168,  171,
      168,  204,  197,  181,  168,  209,  168,  191,  182,  168,
      184,  177,  197,  178,  175,  132,  170,  180,  168,  223,
      168,  176,  168,  224,  183,  185,  179,  213,  168,  171,
      168,  168,  186,  181,  225,  168,  187,  168,  226,  182,
      242,  184,  168,  243,  188,  168,  212,  212,  168,  223,

      168,  210,  205,  224,  183,  185,  213,  266,  412,  168,
      413,  530,  168,  186,  225,  327,  328,  187,  226,  267,
      242,  193,  168,  243,  188,  168,  230,  230,  231,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  230,  230,  230,  230,  230,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,

      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      230,  230,  230,  233,  234,  233,  244,  245,  235,  236,
      234,  236,  246,  247,  237,  248,  249,  250,  251,  530,
      252,  253,  459,  255,  256,  257,  258,  259,  260,  261,
      159,  254,  159,  296,  160,  160,  244,  245,  263,  264,
      263,  168,  246,  247,  163,  248,  249,  241,  250,  251,
      252,  459,  253,  255,  256,  257,  258,  259,  260,  261,
      154,  254,  154,  159,  296,  159,  124,  160,  160,  218,
      299,  168,  166,  156,  159,  156,  167,  167,  200,  200,
      200,  157,  127,  265,  264,  265,  127,  127,  127,  127,

      127,  127,  127,  127,  127,  127,  127,  127,  271,  266,
      127,  299,  272,  168,  168,  127,  127,  127,  127,  127,
      127,  267,  164,  266,  262,  133,  133,  133,  241,  351,
      351,  270,  300,  262,  132,  267,  132,  262,  271,  168,
      217,  132,  272,  168,  168,  262,  211,  127,  127,  127,
      127,  127,  158,  132,  166,  132,  159,  307,  167,  167,
      132,  270,  132,  300,  158,  132,  166,  132,  159,  168,
      167,  167,  132,  273,  132,  168,  127,  127,  127,  132,
      375,  274,  284,  275,  276,  202,  168,  168,  307,  168,
      277,  278,  376,  279,  283,  168,  282,  168,  132,  269,

      297,  168,  168,  273,  285,  168,  298,  168,  286,  168,
      132,  274,  284,  275,  276,  168,  168,  168,  280,  168,
      198,  277,  278,  279,  283,  168,  282,  168,  281,  269,
      297,  168,  168,  168,  285,  287,  298,  168,  286,  168,
      288,  168,  168,  290,  290,  168,  293,  293,  197,  280,
      214,  214,  214,  228,  229,  228,  308,  311,  281,  233,
      234,  233,  312,  168,  235,  287,  309,  310,  313,  321,
      288,  168,  168,  233,  234,  233,  291,  314,  235,  294,
      236,  234,  236,  353,  353,  237,  308,  197,  311,  263,
      264,  263,  194,  312,  327,  328,  309,  310,  193,  313,

      321,  265,  264,  265,  412,  291,  413,  314,  294,  230,
      230,  231,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  230,  230,  230,  230,  230,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  230,  230,  230,  315,  316,  317,  318,

      319,  320,  322,  262,  323,  324,  325,  326,  530,  530,
      203,  203,  262,  132,  168,  132,  262,  126,  168,  131,
      132,  332,  333,  126,  262,  334,  315,  316,  317,  318,
      319,  320,  168,  322,  323,  324,  124,  325,  326,  158,
      132,  166,  132,  159,  168,  167,  167,  132,  168,  132,
      335,  332,  333,  338,  168,  530,  334,  168,  132,  336,
      208,  208,  168,  330,  158,  132,  166,  132,  159,  168,
      167,  167,  132,  168,  132,  168,  530,  339,  355,  168,
      530,  335,  337,  338,  168,  132,  168,  168,  340,  530,
      336,  331,  168,  341,  330,  190,  342,  168,  168,  168,

      356,  343,  346,  168,  344,  168,  345,  339,  355,  168,
      132,  168,  337,  168,  357,  168,  168,  348,  340,  347,
      358,  331,  168,  341,  168,  190,  342,  168,  168,  349,
      356,  343,  346,  359,  360,  344,  168,  345,  361,  350,
      350,  168,  362,  168,  357,  168,  191,  363,  348,  347,
      358,  364,  366,  367,  168,  368,  369,  530,  370,  371,
      349,  372,  374,  359,  168,  360,  168,  375,  530,  361,
      168,  168,  379,  362,  377,  168,  191,  363,  378,  376,
      168,  364,  366,  384,  367,  368,  380,  369,  370,  371,
      168,  372,  374,  168,  168,  381,  530,  168,  382,  168,

      168,  168,  383,  379,  377,  168,  168,  385,  378,  168,
      168,  168,  387,  384,  168,  386,  168,  380,  365,  168,
      168,  390,  394,  168,  388,  397,  381,  168,  382,  168,
      168,  395,  383,  168,  168,  396,  168,  389,  385,  168,
      399,  168,  392,  387,  168,  386,  168,  391,  398,  168,
      400,  390,  403,  394,  388,  190,  397,  404,  405,  409,
      168,  395,  406,  168,  168,  396,  407,  389,  408,  393,
      393,  399,  392,  401,  401,  401,  391,  410,  398,  411,
      400,  418,  403,  402,  168,  168,  414,  404,  415,  405,
      409,  168,  406,  416,  417,  530,  407,  420,  408,  168,

      401,  401,  401,  168,  168,  427,  191,  448,  410,  411,
      402,  418,  168,  168,  168,  168,  414,  419,  421,  415,
      168,  168,  168,  416,  168,  417,  423,  422,  420,  168,
      424,  465,  428,  168,  168,  425,  427,  168,  168,  168,
      431,  426,  168,  168,  432,  437,  168,  419,  421,  433,
      168,  530,  168,  530,  168,  530,  423,  422,  449,  530,
      465,  424,  428,  429,  429,  429,  425,  168,  168,  168,
      431,  426,  442,  430,  432,  437,  168,  434,  434,  434,
      433,  401,  401,  401,  438,  438,  438,  435,  440,  440,
      440,  402,  443,  444,  439,  445,  446,  168,  441,  429,

      429,  429,  168,  442,  450,  168,  451,  458,  452,  430,
      168,  448,  168,  454,  434,  434,  434,  530,  438,  438,
      438,  453,  443,  444,  435,  445,  446,  168,  439,  436,
      168,  460,  168,  168,  450,  168,  451,  458,  168,  452,
      168,  455,  168,  454,  461,  440,  440,  440,  168,  168,
      462,  457,  453,  168,  463,  441,  456,  168,  470,  530,
      168,  460,  449,  168,  429,  429,  429,  168,  168,  464,
      530,  455,  468,  530,  430,  461,  530,  469,  168,  168,
      462,  457,  530,  168,  168,  463,  456,  168,  434,  434,
      434,  438,  438,  438,  440,  440,  440,  168,  435,  168,

      464,  439,  168,  468,  441,  466,  466,  466,  469,  449,
      471,  472,  474,  473,  168,  467,  475,  530,  168,  168,
      466,  466,  466,  168,  476,  530,  477,  478,  448,  168,
      467,  168,  168,  479,  479,  479,  481,  530,  482,  483,
      471,  474,  472,  480,  473,  530,  530,  475,  168,  168,
      484,  484,  484,  168,  168,  476,  477,  492,  478,  168,
      485,  168,  466,  466,  466,  530,  490,  481,  482,  168,
      483,  493,  467,  486,  486,  486,  488,  488,  488,  449,
      479,  479,  479,  487,  168,  494,  489,  492,  530,  168,
      480,  484,  484,  484,  486,  486,  486,  490,  495,  168,

      497,  485,  493,  498,  487,  488,  488,  488,  479,  479,
      479,  484,  484,  484,  502,  489,  494,  496,  480,  168,
      499,  485,  486,  486,  486,  488,  488,  488,  495,  506,
      168,  497,  487,  168,  498,  489,  500,  500,  500,  505,
      508,  503,  530,  507,  168,  502,  501,  496,  168,  168,
      499,  500,  500,  500,  509,  509,  509,  511,  515,  506,
      168,  501,  512,  168,  510,  168,  509,  509,  509,  513,
      505,  508,  503,  507,  168,  168,  510,  514,  168,  516,
      530,  517,  168,  519,  518,  168,  168,  521,  511,  515,
      168,  522,  523,  512,  520,  168,  524,  525,  530,  513,

      527,  526,  529,  168,  530,  168,  168,  514,  168,  528,
      516,  517,  168,  519,  518,  168,  168,  521,  530,  530,
      168,  522,  530,  523,  520,  530,  530,  524,  525,  530,
      527,  168,  526,  168,  295,  530,  168,  530,  168,  528,
      530,  295,  295,  295,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  168,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   80,   80,   80,   80,   80,   80,   80,   80,   80,

       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,  122,
      530,  530,  530,  122,  122,  122,  122,  122,  122,  122,
      122,  122,  122,  122,  122,  122,  122,  122,  122,  122,
      122,  122,  122,  122,  122,  122,  122,  122,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,

      123,  123,  123,  123,  123,  123,  123,  125,  125,  125,
      125,  125,  125,  125,  127,  127,  530,  127,  127,  127,
      127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
      127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
      127,  127,  127,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  132,  132,  132,  530,  530,  132,  132,  530,
      132,  530,  530,  530,  132,  132,  132,  132,  132,  132,
      132,  530,  132,  133,  133,  530,  530,  530,  530,  530,

      133,  133,  133,  133,  133,  133,  133,  155,  530,  155,
      530,  530,  530,  155,  155,  530,  155,  530,  530,  530,
      530,  155,  530,  530,  530,  530,  155,  155,  155,  155,
      155,  155,  155,  158,  530,  158,  530,  158,  530,  158,
      530,  530,  530,  530,  530,  530,  158,  158,  158,  158,
      158,  158,  158,  161,  530,  530,  161,  161,  530,  161,
      161,  161,  530,  530,  530,  530,  161,  161,  161,  161,
      161,  161,  161,  162,  162,  530,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,

      162,  162,  165,  530,  530,  530,  165,  530,  530,  165,
      165,  530,  530,  530,  530,  530,  165,  165,  165,  165,
      165,  165,  165,  168,  168,  168,  168,  168,  530,  168,
      168,  530,  168,  530,  530,  530,  168,  168,  168,  168,
      168,  168,  168,  530,  168,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,

      192,  192,  192,  195,  530,  195,  195,  530,  530,  530,
      530,  530,  195,  195,  195,  195,  195,  195,  195,  530,
      195,  196,  196,  196,  196,  196,  196,  196,  530,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      199,  530,  530,  530,  199,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  201,
      201,  530,  201,  201,  530,  530,  530,  530,  530,  201,
      201,  201,  201,  201,  201,  201,  530,  201,  203,  203,

      203,  203,  203,  203,  530,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  207,  530,  207,
      530,  530,  530,  530,  207,  207,  530,  530,  530,  530,
      530,  530,  207,  207,  207,  207,  207,  207,  207,  207,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  219,
      219,  530,  530,  530,  530,  530,  219,  219,  219,  219,
      219,  219,  219,  530,  219,  122,  122,  122,  122,  122,

      122,  122,  122,  122,  122,  122,  122,  122,  122,  122,
      122,  122,  122,  122,  122,  122,  122,  122,  122,  122,
      122,  122,  122,  122,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  238,  238,  238,  238,  238,  238,  238,
      238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
      238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
      238,  238,  240,  240,  530,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,

      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
      240,  132,  132,  132,  530,  530,  132,  132,  530,  132,
      530,  530,  530,  132,  132,  132,  132,  132,  132,  132,
      530,  132,  133,  133,  133,  530,  530,  530,  530,  133,
      133,  133,  133,  133,  133,  133,  155,  530,  155,  530,
      530,  530,  155,  155,  530,  155,  530,  530,  530,  530,
      155,  530,  530,  530,  530,  155,  155,  155,  155,  155,
      155,  155,  158,  530,  158,  530,  158,  530,  158,  530,
      530,  530,  530,  530,  530,  158,  158,  158,  158,  158,
      158,  158,  161,  161,  530,  161,  161,  161,  530,  530,

      530,  530,  161,  161,  161,  161,  161,  161,  161,  164,
      530,  530,  530,  164,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  164,  164,  164,  164,  164,  164,  164,
      262,  530,  530,  262,  530,  262,  530,  262,  530,  262,
      530,  530,  262,  262,  530,  530,  262,  262,  262,  262,
      262,  262,  262,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  165,  530,  530,  530,  530,  530,  165,  165,
      530,  530,  165,  165,  165,  530,  530,  530,  530,  165,

      165,  165,  165,  165,  165,  165,  268,  530,  530,  268,
      268,  268,  268,  268,  530,  268,  268,  530,  268,  268,
      530,  530,  268,  268,  268,  268,  268,  268,  268,  530,
      268,  168,  168,  168,  168,  168,  530,  168,  168,  530,
      168,  530,  530,  530,  168,  168,  168,  168,  168,  168,
      168,  530,  168,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  530,  530,  530,  530,  530,  530,  530,
      189,  530,  530,  530,  530,  189,  530,  189,  189,  530,

      530,  189,  189,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  195,  530,  195,  195,  530,  530,  530,  530,
      530,  195,  195,  195,  195,  195,  195,  195,  530,  195,
      196,  196,  196,  196,  196,  196,  196,  530,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  199,
      530,  530,  530,  199,  199,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  199,

      199,  199,  199,  199,  199,  199,  199,  199,  201,  201,
      530,  201,  201,  530,  530,  530,  530,  530,  201,  201,
      201,  201,  201,  201,  201,  530,  201,  203,  203,  203,
      203,  203,  203,  530,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  530,  530,
      530,  530,  530,  530,  203,  530,  530,  530,  530,  530,
      530,  530,  203,  530,  530,  203,  530,  203,  207,  207,
      207,  207,  207,  207,  207,  207,  292,  530,  530,  530,
      530,  530,  292,  292,  530,  292,  292,  530,  530,  530,

      530,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  530,  530,  530,  530,  530,  530,  208,  530,
      530,  530,  530,  530,  530,  530,  208,  530,  530,  208,
      530,  208,  219,  219,  530,  530,  530,  530,  530,  219,
      219,  219,  219,  219,  219,  219,  530,  219,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,

      230,  230,  230,  230,  230,  230,  230,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  127,  127,  127,  127,
      127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
      127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
      127,  127,  127,  127,  127,  303,  303,  303,  303,  303,
      303,  303,  303,  303,  303,  303,  303,  303,  303,  303,
      303,  303,  303,  303,  303,  303,  303,  303,  303,  303,
      303,  303,  303,  303,  304,  304,  530,  304,  304,  304,

      304,  304,  304,  304,  304,  304,  304,  304,  304,  304,
      304,  304,  304,  304,  304,  304,  304,  304,  304,  304,
      304,  304,  304,  305,  305,  530,  305,  305,  305,  305,
      305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
      305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
      305,  305,  240,  240,  530,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
      240,  306,  306,  530,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,

      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      132,  132,  132,  530,  530,  132,  132,  530,  132,  530,
      530,  530,  132,  132,  132,  132,  132,  132,  132,  530,
      132,  262,  530,  530,  262,  530,  262,  530,  262,  530,
      262,  530,  530,  262,  262,  530,  530,  262,  262,  262,
      262,  262,  262,  262,  329,  329,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  329,  329,  329,  329,  329,  329,  329,  268,  530,
      530,  268,  268,  268,  268,  268,  530,  268,  268,  530,
      268,  268,  530,  530,  268,  268,  268,  268,  268,  268,

      268,  530,  268,  168,  168,  168,  168,  168,  530,  168,
      168,  530,  168,  530,  530,  530,  168,  168,  168,  168,
      168,  168,  168,  530,  168,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  352,  352,  530,  530,  530,  530,
      530,  352,  352,  352,  354,  354,  530,  530,  530,  530,
      530,  354,  354,  354,  203,  203,  530,  530,  530,  530,
      530,  203,  203,  203,  208,  208,  530,  530,  530,  530,
      530,  208,  208,  208,  447,  447,  447,  447,  447,  447,

      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  447,   15,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,

      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530
    } ;

static yyconst flex_int16_t yy_chk[3812] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    5,    6,    7,    7,    7,    8,    8,    8,    9,
       25,  527,    5,    6,   10,   25,    9,    9,    9,  108,
      108,   10,   10,   10,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   30,   31,
      129,   32,   33,   34,   35,  498,   36,   37,   38,   40,
       39,  129,   35,   31,   41,   47,   42,   47,   41,   47,
       47,   37,   97,  325,   40,   38,   39,  191,  191,   30,
       31,   32,   33,   34,  111,   35,   36,  477,   37,   38,

       40,   39,   35,   31,  403,   41,   42,  316,   46,   41,
       46,   37,  325,   50,   40,   38,   39,   68,   84,   84,
       84,   46,   50,   46,  111,   50,   50,   50,   97,   46,
       49,   49,   93,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,  303,  155,   49,  155,
       55,  155,  155,   49,   49,   49,   49,   49,   49,   51,
       51,   51,   51,   51,   55,   51,   51,   51,   68,   51,
      113,  119,   52,   52,   52,   52,   52,   51,   52,   52,
       52,   55,   52,   93,  301,   49,   49,   49,   49,   49,
      106,  106,  106,   54,   55,  122,  122,  122,   94,   56,

      113,   94,  119,  237,   54,   51,  189,   54,   51,  114,
       56,   94,   94,   56,   49,   49,   49,   58,   52,   53,
       53,   53,   53,   53,   54,   53,   53,   53,   57,   53,
       56,   58,   59,   57,   54,   53,   60,   54,  235,  114,
       56,   57,   57,   56,  105,  105,   59,  230,   58,   53,
       60,  203,  197,   60,   61,  208,   62,  189,   61,   57,
       62,   58,  196,   59,   57,   53,   53,   60,   61,  115,
       62,   57,   57,  116,   61,   62,   59,  105,   63,   53,
       60,   64,   63,   60,  117,   61,   63,   62,  118,   61,
      134,   62,   63,  135,   64,   64,  212,  212,   61,  115,

       62,  208,  203,  116,   61,   62,  105,  164,  376,   63,
      376,  164,   64,   63,  117,  267,  267,   63,  118,  164,
      134,  192,   63,  135,   64,   64,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,

      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  126,  126,  126,  136,  137,  126,  128,
      128,  128,  138,  139,  128,  141,  142,  143,  144,  163,
      145,  146,  428,  147,  148,  149,  150,  151,  152,  153,
      158,  146,  158,  220,  158,  158,  136,  137,  161,  161,
      161,  175,  138,  139,  157,  141,  142,  133,  143,  144,
      145,  428,  146,  147,  148,  149,  150,  151,  152,  153,
      154,  146,  154,  160,  220,  160,  123,  160,  160,  110,
      226,  175,  167,  154,  167,  154,  167,  167,  200,  200,
      200,  154,  162,  162,  162,  162,  162,  162,  162,  162,

      162,  162,  162,  162,  162,  162,  162,  162,  171,  165,
      162,  226,  172,  172,  171,  162,  162,  162,  162,  162,
      162,  165,  165,  266,  166,  165,  165,  165,  165,  290,
      290,  170,  227,  166,  166,  266,  166,  166,  171,  170,
      109,  166,  172,  172,  171,  166,  104,  162,  162,  162,
      162,  162,  168,  168,  168,  168,  168,  242,  168,  168,
      168,  170,  168,  227,  169,  169,  169,  169,  169,  170,
      169,  169,  169,  173,  169,  173,  162,  162,  162,  166,
      375,  174,  184,  176,  177,   92,  174,  176,  242,  177,
      178,  179,  375,  180,  183,  180,  182,  182,  168,  169,

      221,  178,  183,  173,  185,  173,  224,  179,  186,  185,
      169,  174,  184,  176,  177,  186,  174,  176,  181,  177,
       79,  178,  179,  180,  183,  180,  182,  182,  181,  169,
      221,  178,  183,  181,  185,  187,  224,  179,  186,  185,
      188,  188,  187,  205,  205,  186,  210,  210,   78,  181,
      214,  214,  214,  228,  228,  228,  243,  245,  181,  233,
      233,  233,  246,  181,  233,  187,  244,  244,  247,  255,
      188,  188,  187,  234,  234,  234,  205,  248,  234,  210,
      236,  236,  236,  293,  293,  236,  243,   77,  245,  263,
      263,  263,   72,  246,  327,  327,  244,  244,   69,  247,

      255,  265,  265,  265,  412,  205,  412,  248,  210,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  232,  232,  232,  249,  250,  251,  252,

      253,  254,  256,  268,  258,  259,  260,  261,  328,  328,
      351,  351,  268,  268,  271,  268,  268,   48,  284,   27,
      268,  271,  271,   24,  268,  272,  249,  250,  251,  252,
      253,  254,  272,  256,  258,  259,   20,  260,  261,  269,
      269,  269,  269,  269,  271,  269,  269,  269,  284,  269,
      273,  271,  271,  276,  276,   15,  272,  273,  268,  274,
      353,  353,  272,  269,  270,  270,  270,  270,  270,  274,
      270,  270,  270,  275,  270,  277,    0,  277,  297,  278,
        0,  273,  275,  276,  276,  269,  279,  273,  278,    0,
      274,  270,  280,  279,  269,  393,  280,  281,  285,  274,

      299,  281,  285,  275,  282,  277,  283,  277,  297,  278,
      270,  282,  275,  283,  300,  286,  279,  287,  278,  286,
      307,  270,  280,  279,  287,  289,  280,  281,  285,  288,
      299,  281,  285,  309,  310,  282,  288,  283,  312,  289,
      289,  282,  313,  283,  300,  286,  393,  314,  287,  286,
      307,  315,  317,  318,  287,  319,  320,    0,  321,  322,
      288,  324,  326,  309,  331,  310,  288,  329,  329,  312,
      332,  330,  333,  313,  330,  333,  289,  314,  332,  329,
      334,  315,  317,  340,  318,  319,  335,  320,  321,  322,
      337,  324,  326,  338,  331,  336,    0,  335,  337,  339,

      332,  330,  338,  333,  330,  333,  336,  341,  332,  342,
      334,  346,  343,  340,  341,  342,  344,  335,  339,  343,
      337,  347,  355,  338,  344,  359,  336,  335,  337,  339,
      345,  356,  338,  348,  349,  358,  336,  345,  341,  342,
      361,  346,  349,  343,  341,  342,  344,  348,  360,  343,
      362,  347,  364,  355,  344,  350,  359,  365,  366,  371,
      345,  356,  367,  348,  349,  358,  368,  345,  369,  350,
      350,  361,  349,  363,  363,  363,  348,  372,  360,  373,
      362,  381,  364,  363,  377,  388,  377,  365,  378,  366,
      371,  379,  367,  379,  380,    0,  368,  384,  369,  378,

      382,  382,  382,  380,  384,  394,  350,  413,  372,  373,
      382,  381,  385,  383,  377,  388,  377,  383,  385,  378,
      387,  379,  392,  379,  386,  380,  387,  386,  384,  378,
      389,  443,  395,  380,  384,  390,  394,  389,  391,  382,
      397,  391,  385,  383,  398,  404,  390,  383,  385,  399,
      387,    0,  392,    0,  386,    0,  387,  386,  413,    0,
      443,  389,  395,  396,  396,  396,  390,  389,  391,  382,
      397,  391,  407,  396,  398,  404,  390,  400,  400,  400,
      399,  401,  401,  401,  405,  405,  405,  400,  406,  406,
      406,  401,  408,  409,  405,  410,  411,  416,  406,  414,

      414,  414,  415,  407,  415,  423,  416,  427,  417,  414,
      419,  447,  417,  423,  418,  418,  418,    0,  420,  420,
      420,  422,  408,  409,  418,  410,  411,  416,  420,  419,
      422,  431,  415,  424,  415,  423,  416,  427,  414,  417,
      419,  424,  417,  423,  432,  421,  421,  421,  425,  426,
      436,  426,  422,  418,  437,  421,  425,  420,  449,    0,
      422,  431,  447,  424,  429,  429,  429,  452,  414,  442,
        0,  424,  445,    0,  429,  432,    0,  446,  425,  426,
      436,  426,    0,  418,  421,  437,  425,  420,  434,  434,
      434,  438,  438,  438,  440,  440,  440,  452,  434,  454,

      442,  438,  450,  445,  440,  444,  444,  444,  446,  449,
      450,  451,  454,  453,  421,  444,  456,    0,  451,  453,
      455,  455,  455,  456,  457,    0,  458,  459,  470,  454,
      455,  457,  450,  460,  460,  460,  462,    0,  463,  464,
      450,  454,  451,  460,  453,    0,    0,  456,  451,  453,
      465,  465,  465,  456,  472,  457,  458,  478,  459,  455,
      465,  457,  466,  466,  466,    0,  473,  462,  463,  473,
      464,  481,  466,  468,  468,  468,  469,  469,  469,  470,
      471,  471,  471,  468,  472,  482,  469,  478,    0,  455,
      471,  474,  474,  474,  475,  475,  475,  473,  483,  473,

      491,  474,  481,  492,  475,  476,  476,  476,  479,  479,
      479,  484,  484,  484,  495,  476,  482,  490,  479,  471,
      493,  484,  486,  486,  486,  488,  488,  488,  483,  502,
      474,  491,  486,  475,  492,  488,  494,  494,  494,  499,
      504,  496,    0,  503,  476,  495,  494,  490,  496,  471,
      493,  500,  500,  500,  505,  505,  505,  506,  513,  502,
      474,  500,  507,  475,  505,  507,  509,  509,  509,  511,
      499,  504,  496,  503,  476,  512,  509,  512,  496,  514,
        0,  515,  516,  517,  516,  518,  514,  519,  506,  513,
      520,  520,  521,  507,  518,  507,  522,  523,    0,  511,

      525,  524,  528,  526,    0,  512,  522,  512,  524,  526,
      514,  515,  516,  517,  516,  518,  514,  519,    0,    0,
      520,  520,    0,  521,  518,    0,    0,  522,  523,    0,
      525,  528,  524,  526,  585,    0,  522,    0,  524,  526,
        0,  585,  585,  585,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  528,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  532,  532,  532,  532,  532,  532,  532,  532,  532,

      532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
      532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
      533,  533,  533,  533,  533,  533,  533,  533,  533,  533,
      533,  533,  533,  533,  533,  533,  533,  533,  533,  533,
      533,  533,  533,  533,  533,  533,  533,  533,  533,  534,
        0,    0,    0,  534,  534,  534,  534,  534,  534,  534,
      534,  534,  534,  534,  534,  534,  534,  534,  534,  534,
      534,  534,  534,  534,  534,  534,  534,  534,  535,  535,
      535,  535,  535,  535,  535,  535,  535,  535,  535,  535,
      535,  535,  535,  535,  535,  535,  535,  535,  535,  535,

      535,  535,  535,  535,  535,  535,  535,  536,  536,  536,
      536,  536,  536,  536,  537,  537,    0,  537,  537,  537,
      537,  537,  537,  537,  537,  537,  537,  537,  537,  537,
      537,  537,  537,  537,  537,  537,  537,  537,  537,  537,
      537,  537,  537,  538,  538,  538,  538,  538,  538,  538,
      538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
      538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
      538,  538,  539,  539,  539,    0,    0,  539,  539,    0,
      539,    0,    0,    0,  539,  539,  539,  539,  539,  539,
      539,    0,  539,  540,  540,    0,    0,    0,    0,    0,

      540,  540,  540,  540,  540,  540,  540,  541,    0,  541,
        0,    0,    0,  541,  541,    0,  541,    0,    0,    0,
        0,  541,    0,    0,    0,    0,  541,  541,  541,  541,
      541,  541,  541,  542,    0,  542,    0,  542,    0,  542,
        0,    0,    0,    0,    0,    0,  542,  542,  542,  542,
      542,  542,  542,  543,    0,    0,  543,  543,    0,  543,
      543,  543,    0,    0,    0,    0,  543,  543,  543,  543,
      543,  543,  543,  544,  544,    0,  544,  544,  544,  544,
      544,  544,  544,  544,  544,  544,  544,  544,  544,  544,
      544,  544,  544,  544,  544,  544,  544,  544,  544,  544,

      544,  544,  545,    0,    0,    0,  545,    0,    0,  545,
      545,    0,    0,    0,    0,    0,  545,  545,  545,  545,
      545,  545,  545,  546,  546,  546,  546,  546,    0,  546,
      546,    0,  546,    0,    0,    0,  546,  546,  546,  546,
      546,  546,  546,    0,  546,  547,  547,  547,  547,  547,
      547,  547,  547,  547,  547,  547,  547,  547,  547,  547,
      547,  547,  547,  547,  547,  547,  547,  547,  547,  547,
      547,  547,  547,  547,  548,  548,  548,  548,  548,  548,
      548,  548,  548,  548,  548,  548,  548,  548,  548,  548,
      548,  548,  548,  548,  548,  548,  548,  548,  548,  548,

      548,  548,  548,  549,    0,  549,  549,    0,    0,    0,
        0,    0,  549,  549,  549,  549,  549,  549,  549,    0,
      549,  550,  550,  550,  550,  550,  550,  550,    0,  550,
      550,  550,  550,  550,  550,  550,  550,  550,  550,  550,
      550,  550,  550,  550,  550,  550,  550,  550,  550,  550,
      551,    0,    0,    0,  551,  551,  551,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  551,  552,
      552,    0,  552,  552,    0,    0,    0,    0,    0,  552,
      552,  552,  552,  552,  552,  552,    0,  552,  553,  553,

      553,  553,  553,  553,    0,  553,  553,  553,  553,  553,
      553,  553,  553,  553,  553,  553,  553,  553,  553,  553,
      553,  553,  553,  553,  553,  553,  553,  554,    0,  554,
        0,    0,    0,    0,  554,  554,    0,    0,    0,    0,
        0,    0,  554,  554,  554,  554,  554,  554,  554,  554,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  556,
      556,    0,    0,    0,    0,    0,  556,  556,  556,  556,
      556,  556,  556,    0,  556,  557,  557,  557,  557,  557,

      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  558,  558,  558,  558,  558,  558,
      558,  558,  558,  558,  558,  558,  558,  558,  558,  558,
      558,  558,  558,  558,  558,  558,  558,  558,  558,  558,
      558,  558,  558,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  560,  560,    0,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,

      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  561,  561,  561,    0,    0,  561,  561,    0,  561,
        0,    0,    0,  561,  561,  561,  561,  561,  561,  561,
        0,  561,  562,  562,  562,    0,    0,    0,    0,  562,
      562,  562,  562,  562,  562,  562,  563,    0,  563,    0,
        0,    0,  563,  563,    0,  563,    0,    0,    0,    0,
      563,    0,    0,    0,    0,  563,  563,  563,  563,  563,
      563,  563,  564,    0,  564,    0,  564,    0,  564,    0,
        0,    0,    0,    0,    0,  564,  564,  564,  564,  564,
      564,  564,  565,  565,    0,  565,  565,  565,    0,    0,

        0,    0,  565,  565,  565,  565,  565,  565,  565,  566,
        0,    0,    0,  566,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  566,  566,  566,  566,  566,  566,  566,
      567,    0,    0,  567,    0,  567,    0,  567,    0,  567,
        0,    0,  567,  567,    0,    0,  567,  567,  567,  567,
      567,  567,  567,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  569,    0,    0,    0,    0,    0,  569,  569,
        0,    0,  569,  569,  569,    0,    0,    0,    0,  569,

      569,  569,  569,  569,  569,  569,  570,    0,    0,  570,
      570,  570,  570,  570,    0,  570,  570,    0,  570,  570,
        0,    0,  570,  570,  570,  570,  570,  570,  570,    0,
      570,  571,  571,  571,  571,  571,    0,  571,  571,    0,
      571,    0,    0,    0,  571,  571,  571,  571,  571,  571,
      571,    0,  571,  572,  572,  572,  572,  572,  572,  572,
      572,  572,  572,  572,  572,  572,  572,  572,  572,  572,
      572,  572,  572,  572,  572,  572,  572,  572,  572,  572,
      572,  572,  573,    0,    0,    0,    0,    0,    0,    0,
      573,    0,    0,    0,    0,  573,    0,  573,  573,    0,

        0,  573,  573,  574,  574,  574,  574,  574,  574,  574,
      574,  574,  574,  574,  574,  574,  574,  574,  574,  574,
      574,  574,  574,  574,  574,  574,  574,  574,  574,  574,
      574,  574,  575,    0,  575,  575,    0,    0,    0,    0,
        0,  575,  575,  575,  575,  575,  575,  575,    0,  575,
      576,  576,  576,  576,  576,  576,  576,    0,  576,  576,
      576,  576,  576,  576,  576,  576,  576,  576,  576,  576,
      576,  576,  576,  576,  576,  576,  576,  576,  576,  577,
        0,    0,    0,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,

      577,  577,  577,  577,  577,  577,  577,  577,  578,  578,
        0,  578,  578,    0,    0,    0,    0,    0,  578,  578,
      578,  578,  578,  578,  578,    0,  578,  579,  579,  579,
      579,  579,  579,    0,  579,  579,  579,  579,  579,  579,
      579,  579,  579,  579,  579,  579,  579,  579,  579,  579,
      579,  579,  579,  579,  579,  579,  580,  580,    0,    0,
        0,    0,    0,    0,  580,    0,    0,    0,    0,    0,
        0,    0,  580,    0,    0,  580,    0,  580,  581,  581,
      581,  581,  581,  581,  581,  581,  582,    0,    0,    0,
        0,    0,  582,  582,    0,  582,  582,    0,    0,    0,

        0,  582,  582,  582,  582,  582,  582,  582,  582,  582,
      582,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      584,  584,    0,    0,    0,    0,    0,    0,  584,    0,
        0,    0,    0,    0,    0,    0,  584,    0,    0,  584,
        0,  584,  586,  586,    0,    0,    0,    0,    0,  586,
      586,  586,  586,  586,  586,  586,    0,  586,  587,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,

      587,  587,  587,  587,  587,  587,  587,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  590,  590,  590,  590,  590,
      590,  590,  590,  590,  590,  590,  590,  590,  590,  590,
      590,  590,  590,  590,  590,  590,  590,  590,  590,  590,
      590,  590,  590,  590,  591,  591,    0,  591,  591,  591,

      591,  591,  591,  591,  591,  591,  591,  591,  591,  591,
      591,  591,  591,  591,  591,  591,  591,  591,  591,  591,
      591,  591,  591,  592,  592,    0,  592,  592,  592,  592,
      592,  592,  592,  592,  592,  592,  592,  592,  592,  592,
      592,  592,  592,  592,  592,  592,  592,  592,  592,  592,
      592,  592,  593,  593,    0,  593,  593,  593,  593,  593,
      593,  593,  593,  593,  593,  593,  593,  593,  593,  593,
      593,  593,  593,  593,  593,  593,  593,  593,  593,  593,
      593,  594,  594,    0,  594,  594,  594,  594,  594,  594,
      594,  594,  594,  594,  594,  594,  594,  594,  594,  594,

      594,  594,  594,  594,  594,  594,  594,  594,  594,  594,
      595,  595,  595,    0,    0,  595,  595,    0,  595,    0,
        0,    0,  595,  595,  595,  595,  595,  595,  595,    0,
      595,  596,    0,    0,  596,    0,  596,    0,  596,    0,
      596,    0,    0,  596,  596,    0,    0,  596,  596,  596,
      596,  596,  596,  596,  597,  597,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  597,  597,  597,  597,  597,  597,  597,  598,    0,
        0,  598,  598,  598,  598,  598,    0,  598,  598,    0,
      598,  598,    0,    0,  598,  598,  598,  598,  598,  598,

      598,    0,  598,  599,  599,  599,  599,  599,    0,  599,
      599,    0,  599,    0,    0,    0,  599,  599,  599,  599,
      599,  599,  599,    0,  599,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  601,  601,    0,    0,    0,    0,
        0,  601,  601,  601,  602,  602,    0,    0,    0,    0,
        0,  602,  602,  602,  603,  603,    0,    0,    0,    0,
        0,  603,  603,  603,  604,  604,    0,    0,    0,    0,
        0,  604,  604,  604,  605,  605,  605,  605,  605,  605,

      605,  605,  605,  605,  605,  605,  605,  605,  605,  605,
      605,  605,  605,  605,  605,  605,  605,  605,  605,  605,
      605,  605,  605,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,

      530,  530,  530,  530,  530,  530,  530,  530,  530,  530,
      530
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[106] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 
    0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 
    0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 
    1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 
    1, 0, 1, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2014 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*       http://www.apache.org/licenses/LICENSE-2.0
*       -or-
*       see COPYING.ASL20 in the source distribution
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

#line 38 "lexer.l"
#include "parserif.h"
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* INCALL: support for the call statement */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 71 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
#if !defined(__FreeBSD__)
int fileno(FILE *stream);
#endif

#line 1616 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define INCALL 5
#define EXPR 6

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 106 "lexer.l"


 /* keywords */
#line 1814 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 531 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 3724 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 109 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 110 "lexer.l"
{ BEGIN EXPR; return FOREACH; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 111 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 112 "lexer.l"
{ BEGIN INITIAL; return DO; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 113 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 114 "lexer.l"
{ return OR; }
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 115 "lexer.l"
{ return AND; }
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 116 "lexer.l"
{ return NOT; }
	YY_BREAK
case 9:
#line 118 "lexer.l"
case 10:
#line 119 "lexer.l"
case 11:
#line 120 "lexer.l"
case 12:
#line 121 "lexer.l"
case 13:
#line 122 "lexer.l"
case 14:
#line 123 "lexer.l"
case 15:
#line 124 "lexer.l"
case 16:
#line 125 "lexer.l"
case 17:
#line 126 "lexer.l"
case 18:
#line 127 "lexer.l"
case 19:
#line 128 "lexer.l"
case 20:
YY_RULE_SETUP
#line 128 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 129 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 130 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 131 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 24:
#line 133 "lexer.l"
case 25:
YY_RULE_SETUP
#line 133 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 134 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 135 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 136 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 137 "lexer.l"
{ return ITERATOR_ASSIGNMENT; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 138 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 139 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 140 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 33:
#line 142 "lexer.l"
case 34:
#line 143 "lexer.l"
case 35:
YY_RULE_SETUP
#line 143 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 144 "lexer.l"
{ yylval.s = strdup(yytext+1); return VAR; }
	YY_BREAK
case 37:
/* rule 37 can match eol */
YY_RULE_SETUP
#line 145 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 38:
/* rule 38 can match eol */
YY_RULE_SETUP
#line 150 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 155 "lexer.l"

	YY_BREAK
case 40:
YY_RULE_SETUP
#line 156 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 158 "lexer.l"
{ parser_errmsg("invalid character '%s' in expression "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 42:
/* rule 42 can match eol */
YY_RULE_SETUP
#line 161 "lexer.l"

	YY_BREAK
case 43:
YY_RULE_SETUP
#line 162 "lexer.l"
{ parser_errmsg("invalid character '%s' in 'call' statement"
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 165 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  BEGIN INITIAL;
				  return NAME; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 168 "lexer.l"
{ return '&'; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 169 "lexer.l"
{ return '{'; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 170 "lexer.l"
{ return '}'; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 171 "lexer.l"
{ return STOP; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 172 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 173 "lexer.l"
{ BEGIN INCALL; return CALL; }
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 174 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 175 "lexer.l"
{ BEGIN EXPR; return RESET; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 176 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 177 "lexer.l"
{ return CONTINUE; }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 55:
YY_RULE_SETUP
#line 181 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 182 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 183 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 184 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 188 "lexer.l"

	YY_BREAK
case 60:
YY_RULE_SETUP
#line 189 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 192 "lexer.l"
{ yylval.objType = CNFOBJ_MAINQ;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 194 "lexer.l"
{ yylval.objType = CNFOBJ_TIMEZONE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 196 "lexer.l"
{ yylval.objType = CNFOBJ_PARSER;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 198 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 200 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 202 "lexer.l"
{ yylval.objType = CNFOBJ_RULESET;
				  BEGIN INOBJ; return BEGIN_RULESET; }
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 204 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 206 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 208 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 210 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 212 "lexer.l"
{ yylval.objType = CNFOBJ_LOOKUP_TABLE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 214 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 215 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext));
				  dbgprintf("lexer: propfilt is '%s'\n", yylval.s);
				  return PROPFILT;
				  }
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 220 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 75:
#line 222 "lexer.l"
case 76:
#line 223 "lexer.l"
case 77:
/* rule 77 can match eol */
#line 224 "lexer.l"
case 78:
/* rule 78 can match eol */
#line 225 "lexer.l"
case 79:
/* rule 79 can match eol */
#line 226 "lexer.l"
case 80:
/* rule 80 can match eol */
#line 227 "lexer.l"
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 227 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 228 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 229 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 84:
#line 232 "lexer.l"
case 85:
#line 233 "lexer.l"
case 86:
#line 234 "lexer.l"
case 87:
YY_RULE_SETUP
#line 234 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 235 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
/*yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }*/
case 89:
YY_RULE_SETUP
#line 242 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 243 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 244 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 245 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 93:
/* rule 93 can match eol */
YY_RULE_SETUP
#line 246 "lexer.l"

	YY_BREAK
case 94:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 247 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 95:
/* rule 95 can match eol */
YY_RULE_SETUP
#line 248 "lexer.l"

	YY_BREAK
case 96:
YY_RULE_SETUP
#line 249 "lexer.l"
{ parser_errmsg("invalid character '%s' in object definition "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 97:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 252 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 98:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 263 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 99:
/* rule 99 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 264 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 100:
/* rule 100 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 265 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 101:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 266 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 102:
/* rule 102 can match eol */
YY_RULE_SETUP
#line 267 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 103:
/* rule 103 can match eol */
YY_RULE_SETUP
#line 268 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 269 "lexer.l"
{ parser_errmsg("invalid character '%s' "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(INCALL):
case YY_STATE_EOF(EXPR):
#line 272 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 274 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2482 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 531 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 531 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 530);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 274 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, 1 on error, 2 on file not exists.
 * note: in case of error, errno must be kept valid!
 */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 2;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
	dbgprintf("config parser: pushed file %s on top of stack\n", fname);

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	dbgprintf("config parser: reached end of file %s\n", bs->fn);
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL) {
		dbgprintf("config parser: parsing completed\n");
		return 1; /* all processed */
	}
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	dbgprintf("config parser: resume parsing of file %s at line %d\n",
		  cnfcurrfn, yylineno);
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

